SuperStrict
Framework brl.standardio
Import brl.blitz
Import brl.filesystem
Import brl.stream
Import brl.retro
Import brl.math
Import brl.random

Global e!=Exp(1)'2.71828182845904523536
Const gold!=(1+5^.5)/Double(2)
Global parab!=Log(1+2^.5)+2^.5

Global path$="code.txt"
If AppArgs.length>1 Then
	Local ona%=0
	For Local a$=EachIn AppArgs
		ona:+1
		If ona=2 Then path=a
	Next
EndIf


Global code%[1]

Local fil:TStream=ReadFile(path)
If Not fil Print "Could not load "+path;Input;End

Global cst![1]
Global cnum:Long=0

Global txt$[1]
Global tnum:Long=0


Global size:Long=1
Global ends%=0
Global inparen%=0
Global comment%=0
Repeat
	Local b$=Trim(Replace(ReadLine(fil),Chr(9)," "))
	Local p%=0,resize%=1,set%=0
	Repeat
		resize=1
		Select Lower(Mid(b,p,3))
			'Case "new" set=0
			Case "end" set=1
			Case "nxt" set=2
			Case "lst" set=3
			Case "org" set=4
			Case "lin" set=5
			Case "inc" set=6
			Case "dec" set=7
			Case "zro" set=8
			Case "out" set=9
			Case "inp" set=10
			Case "prn" set=11
			Case "psh" set=12
			Case "pop" set=13
			Case "add" set=14
			Case "sub" set=15
			Case "mul" set=16
			Case "div" set=17
			Case "pwr" set=18
			Case "max" set=19
			Case "min" set=20
			Case "clr" set=21
			Case "trg" set=22
			Case "jmp" set=23
			Case "rnd" set=24
			Case "flr" set=25
			Case "cel" set=26
			Case "sin" set=27
			Case "cos" set=28
			Case "tan" set=29
			Case "asn" set=30
			Case "acs" set=31
			Case "atn" set=32
			Case "=pi" set=33
			Case "=e=" set=34
			Case "fc1" set=35
			Case "fc2" set=36
			Case "ape" set=37
			Case "gld" set=38
			Case "emc" set=39
			Case "lpl" set=40
			Case "log" set=41
			Case "prb" set=42
			Case "mlc" set=43
			Case "abs" set=44
			Case "neg" set=45
			Case "and" set=46
			Case "bor" set=47
			Case "xor" set=48
			Case "snh" set=49
			Case "csh" set=50
			Case "tnh" set=51
			Case "not" set=52
			Case "exp" set=53
			Case "1/x" set=54
			Case "vsn" set=55
			Case "sec" set=56
			Case "csc" set=57
			Case "cot" set=58
			Case "exs" set=59
			Case "sic" set=60
			Case "sdc" set=61
			Case "mod" set=62
			Case "stk" set=63
			Case "str" set=64
			Case "one" set=65
			Case "deg" set=66
			Case "rad" set=67
			Case "sto" set=68
			Case "sgn" set=69
			Case "rnd" set=70
			Default resize=0
		End Select
		If (resize=1) And (comment=0) 
			code=code[..size+1];code[size]=set;size:+1
		EndIf
		If Mid(b,p,2)="//" And p<Len(b) comment=Not comment
		If Mid(b,p,1)="[" And comment=0
			Local get$=""
			Repeat
				p:+1;Local c$=Mid(b,p,1)
				If c="]" Exit
				If p=>Len(b) Print "ERROR: Unclosed [...] encountered"
				get:+c
			Forever
			cnum:+1
			cst=cst[..cnum]
			cst[cnum-1]=Double(get)
			code=code[..size+1];code[size]=255;size:+1
			code=code[..size+1];code[size]=cnum-1;size:+1
		EndIf
		If Mid(b,p,1)="(" And comment=0
			Local get$=""
			Repeat
				p:+1;Local c$=Mid(b,p,1)
				If c=")" Exit
				If p=>Len(b) Print "ERROR: Unclosed (...) encountered"
				get:+c
			Forever
			tnum:+1
			txt=txt[..tnum]
			txt[tnum-1]=get
			code=code[..size+1];code[size]=254;size:+1
			code=code[..size+1];code[size]=tnum-1;size:+1
		EndIf
		If resize p:+3 Else p:+1
		If p>Len(b) Exit
	Forever
Until Eof(fil)






Global mem:Long=0
Global memory:Double[64],msize%=64
Global mmod%=0
Function get:Double(x:Long)
	If x+mmod<0 Then 
		mmod=-x;memory=memory[..msize+mmod]
		For Local rsize%=0 To msize+mmod-2
			memory[msize+mmod-1-rsize]=memory[msize+mmod-2-rsize]
		Next
		memory[0]=0
	EndIf
	If x=>msize Then msize:+1;memory=memory[..msize+mmod]
	If x+mmod<0
		Print msize+mmod
		Print x+mmod
	EndIf
	Return memory[x+mmod]
End Function
Function set(x:Long,s:Double)
	get x
	memory[x+mmod]=s
End Function


Global stack:TList=CreateList()
Type val
	Field v!
End Type


Print ""
Print "Executing program.."
Print ""


Local pos:Long=0
Repeat
	If pos=>size Exit
	Select code[pos]
		Case 00
		Case 01 'end
			Exit
		Case 02 'nxt
			mem:+1
		Case 03 'bck
			mem:-1
		Case 04 'org
			mem=0
		Case 05 'lin
			Print ""
		Case 06 'inc
			set(mem,get(mem)+1)
		Case 07 'dec
			set(mem,get(mem)-1)
		Case 08 'zro
			set(mem,0)
		Case 09 'out
			WriteStdout get(mem)
		Case 10 'inp
			set(mem,Double(Input()))
		Case 11 'prn
			WriteStdout Chr(Byte(get(mem)))
		Case 12 'psh
			Local l:val=New val;l.v=get(mem)
			stack.addlast l
		Case 13 'pop
			Local l:val=val(stack.first())
			If l
				set(mem,l.v)
				stack.remove l
			EndIf
		Case 14 'add
			Local res!=0
			For Local l:val=EachIn stack
				res:+l.v
			Next
			Local l:val=New val
			l.v=res
			ClearList stack;stack.addlast l
		Case 15 'sub
			Local res!=0,on:Long=0
			For Local l:val=EachIn stack
				If on=0 res=l.v;on:+1 Else res:-l.v
			Next
			Local l:val=New val
			l.v=res
			ClearList stack;stack.addlast l
		Case 16 'mul
			Local res!=1
			For Local l:val=EachIn stack
				res:*l.v
			Next
			Local l:val=New val
			l.v=res
			ClearList stack;stack.addlast l
		Case 17 'div
			Local res!=0,on:Long=0
			For Local l:val=EachIn stack
				If on=0 res=l.v;on:+1 Else res:/l.v
			Next
			Local l:val=New val
			l.v=res
			ClearList stack;stack.addlast l
		Case 18 'pwr
			Local res!=0,on:Long=0
			For Local l:val=EachIn stack
				If on=0 res=l.v;on:+1 Else res=res^l.v
			Next
			Local l:val=New val
			l.v=res
			ClearList stack;stack.addlast l
		Case 19 'max
			Local res!=0,on:Long=0
			For Local l:val=EachIn stack
				If on=0 res=l.v;on:+1 ElseIf l.v>res res=l.v
			Next
			Local l:val=New val
			l.v=res
			ClearList stack;stack.addlast l
		Case 20 'min
			Local res!=0,on:Long=0
			For Local l:val=EachIn stack
				If on=0 res=l.v;on:+1 ElseIf l.v<res res=l.v
			Next
			Local l:val=New val
			l.v=res
			ClearList stack;stack.addlast l
		Case 21 'clr
			ClearList stack
		Case 22 'trg
			Repeat
				pos:-1
				If pos<0 Then Print"";Print "ERROR: unopened jmp/trg encountered.";Exit
			Until code[pos]=23
			pos:-1
		Case 23 'jmp
			If get(mem)=<0
				Repeat
					pos:+1
					If pos=>size Then Print"";Print "ERROR: unclosed jmp/trg encountered.";Exit
				Until code[pos]=22
			EndIf
		Case 24 'rnd
			For Local l:val=EachIn stack
				l.v=round(l.v)
			Next
		Case 25 'flr
			For Local l:val=EachIn stack
				l.v=Floor(l.v)
			Next
		Case 26 'cel
			For Local l:val=EachIn stack
				l.v=Ceil(l.v)
			Next
		Case 27 'sin
			For Local l:val=EachIn stack
				l.v=Sin(l.v)
			Next
		Case 28 'cos
			For Local l:val=EachIn stack
				l.v=Cos(l.v)
			Next
		Case 29 'tan
			For Local l:val=EachIn stack
				l.v=Tan(l.v)
			Next
		Case 30 'asn
			For Local l:val=EachIn stack
				l.v=ASin(l.v)
			Next
		Case 31 'acs
			For Local l:val=EachIn stack
				l.v=ACos(l.v)
			Next
		Case 32 'atn
			For Local l:val=EachIn stack
				l.v=ATan(l.v)
			Next
		Case 33 '=pi
			set(mem,Pi)
		Case 34 '=e=
			set(mem,e)
		Case 35 'fc1
			set(mem,Double(4.66920160910299067185320382))
		Case 36 'fc2
			set(mem,Double(2.502907875095892822283902873218))
		Case 37 'ape
			set(mem,Double(1.202056903159594285399738161511449990764986292))
		Case 38 'gld
			set(mem,gold)
		Case 39 'emc
			set(mem,Double(0.57721566490153286060651209008240243104215933593992))
		Case 40 'lpl
			set(mem,Double(0.66274341934918158097474209710925290))
		Case 41 'log
			set(mem,Log(get(mem)))
		Case 42 'prb
			set(mem,parab)
		Case 43 'mlc
			set(mem,1.3063778838630806904686144926)
		Case 44 'abs
			For Local l:val=EachIn stack
				l.v=Abs(l.v)
			Next
		Case 45 'neg
			For Local l:val=EachIn stack
				l.v=-l.v
			Next
		Case 46 'and
			Local res:Long=0,on:Long=0
			For Local l:val=EachIn stack
				If on=0 res=l.v;on:+1 Else res=Long(res) & Long(l.v)
			Next
			Local l:val=New val
			l.v=res
			ClearList stack;stack.addlast l
		Case 47 'bor
			Local res:Long=0,on:Long=0
			For Local l:val=EachIn stack
				If on=0 res=l.v;on:+1 Else res=Long(res) | Long(l.v)
			Next
			Local l:val=New val
			l.v=res
			ClearList stack;stack.addlast l
		Case 48 'xor
			Local res:Long=0,on:Long=0
			For Local l:val=EachIn stack
				If on=0 res=l.v;on:+1 Else res=xor( Long(res) , Long(l.v) )
			Next
			Local l:val=New val
			l.v=res
			ClearList stack;stack.addlast l
		Case 49 'snh
			For Local l:val=EachIn stack
				l.v=Sinh(l.v)
			Next
		Case 50 'csh
			For Local l:val=EachIn stack
				l.v=Cosh(l.v)
			Next
		Case 51 'tnh
			For Local l:val=EachIn stack
				l.v=Tanh(l.v)
			Next
		Case 52 'not
			For Local l:val=EachIn stack
				l.v=~Long(l.v)
			Next
		Case 53 'exp
			For Local l:val=EachIn stack
				l.v=Exp(l.v)
			Next
		Case 54 '1/x
			For Local l:val=EachIn stack
				l.v=1/Double(l.v)
			Next
		Case 55 'vsn
			For Local l:val=EachIn stack
				l.v=1-Cos(l.v)
			Next
		Case 56 'sec
			For Local l:val=EachIn stack
				l.v=1/Cos(l.v)
			Next
		Case 57 'csc
			For Local l:val=EachIn stack
				l.v=1/Sin(l.v)
			Next
		Case 58 'cot
			For Local l:val=EachIn stack
				l.v=1/Tan(l.v)
			Next
		Case 59 'exs
			For Local l:val=EachIn stack
				l.v=1/Cos(l.v)-1
			Next
		Case 60 'sic
			For Local l:val=EachIn stack
				l.v:+1
			Next
		Case 61 'sdc
			For Local l:val=EachIn stack
				l.v:-1
			Next
		Case 62 'mod
			For Local l:val=EachIn stack
				l.v=l.v Mod get(mem)
			Next
		Case 63 'stk
			Print ""
			For Local l:val=EachIn stack
				Print l.v
			Next
		Case 64 'str
			Local out$=""
			For Local l:val=EachIn stack
				out:+Chr(l.v)
			Next
			WriteStdout out
		Case 65 'one
			set(mem,1)
		Case 66 'deg
			For Local l:val=EachIn stack
				l.v:/(Pi/Double(180))
			Next
		Case 67 'rad
			For Local l:val=EachIn stack
				l.v:*(Pi/Double(180))
			Next
		Case 68 'sto
			Local l:val=val(stack.first())
			If l
				set(mem,l.v)
			EndIf		
		Case 69 'sgn
			For Local l:val=EachIn stack
				If l.v>0 l.v=1
				If l.v<0 l.v=-1
			Next
		Case 70 'rnd
			Local l:val=New val
			l.v=Rnd()
			stack.addlast l
			
			
		Case 254
			WriteStdout(txt[code[pos+1]])
			pos:+1
		Case 255
			set(mem,cst[code[pos+1]])
			pos:+1
	End Select
	pos:+1
Forever

Print ""
Print ""
Print "Execution complete."
Input
End




Function xor:Long(x:Long,y:Long)
	Local ret:Long=0 
	For Local go%=0 To 63 
		Local bit1%=x Shr go Mod 2 
		Local bit2%=y Shr go Mod 2 
		If ((Not bit1)|(Not bit2)) & ((bit1)|(bit2)) Then ret:+2^go
	Next 
	Return ret 
End Function 


Function round:Double(num:Double)
	Local dec:Double=num Mod 1
	If dec=>.5 Return num+(1-dec)
	Return num-dec
End Function
